﻿using System.Diagnostics;
using System.IO;
using System.Net.Security;
using System.Net.Sockets;

namespace SecureSimpleTcpClient
{
    internal class SimpleSecureClient
    {
        public SimpleSecureClient(string server, int port, string certificateServerName, string request)
        {
            using (TcpClient client = new TcpClient(server, port))
            {
                Trace.WriteLine("Client connected to server");
                NetworkStream ordinaryStream = client.GetStream();

                // Decorator/Wrapper design pattern
                SslStream sslStream = new SslStream(ordinaryStream, false);
                sslStream.AuthenticateAsClient(certificateServerName);

                StreamWriter writer = new StreamWriter(sslStream);
                writer.Write(request);
                writer.Flush();
                StreamReader reader = new StreamReader(sslStream);
                string response = reader.ReadLine();
                Trace.WriteLine("Client: Response from server: " + response);
            }
        }
    }
}